
-- Triolet
-- 
--
-- @author @poc@lypse
-- 	


Triolet = {};


function Triolet.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function Triolet:load(xmlFile)
self.Speed = getXMLFloat(xmlFile, "vehicle.Speed#value");



local count = getXMLInt(xmlFile, "vehicle.drums#count");
    self.drums = {};
	local part = self.drums;
    for i=1, count do
		part[i] = {};
        local partname = string.format("vehicle.drums.drum" .. "%d", i);
	    part[i].index = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partname .. "#index"));
		local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, partname .. "#rot"));
		part[i].rot = {};
	    part[i].rot[1] = Utils.getNoNil(x, 0);
	    part[i].rot[2] = Utils.getNoNil(y, 0);
	    part[i].rot[3] = Utils.getNoNil(z, 0);
		for j=1, 3 do
			if part[i].rot[j] ~= 0 then
				part[i].rot[j] = 1/part[i].rot[j]
			end;
		end;
    end;
	

end;

function Triolet:delete()
    
end;

function Triolet:mouseEvent(posX, posY, isDown, isUp, button)
  
end;

function Triolet:keyEvent(unicode, sym, modifier, isDown)
end;



function Triolet:update(dt)
if self:getIsActiveForInput() then
  if InputBinding.hasEvent(InputBinding.TRIOLET_WORK) then
    self.isEnabled = not self.isEnabled;   
  end;
	
   
		
	
		if self.isEnabled then
			
                       for i=1, table.getn(self.drums) do
				rotate(self.drums[i].index, dt*self.drums[i].rot[1], dt*self.drums[i].rot[2], dt*self.drums[i].rot[3]);
		       end;
                        for k, cuttingArea in pairs(self.cuttingAreas) do
                           if self:getIsAreaActive(cuttingArea) then
				 local x,y,z = getWorldTranslation(cuttingArea.start);
                                 local x1,y1,z1 = getWorldTranslation(cuttingArea.width);
                                 local x2,y2,z2 = getWorldTranslation(cuttingArea.height);
                             local old, total = Utils.getFruitWindrowArea(FruitUtil.FRUITTYPE_MAIZE, x, z, x1, z1, x2, z2);
                             local value = 1+math.floor(old / total + 0.7); 
                             value = math.min(value, g_currentMission.maxWindrowValue);
                             Utils.updateFruitWindrowArea(FruitUtil.FRUITTYPE_MAIZE, x, z, x1, z1, x2, z2, value, true);
                          end;                        
			local delta = self.Speed * dt;                      
			self:setFillLevel(self.fillLevel-delta, self.currentFillType); 
                        local fillType = Fillable.FILLTYPE_DRYGRASS;
                        local siloAmount = g_currentMission:getSiloAmount(fillType);                                             
                        g_currentMission:setSiloAmount(fillType, math.min(siloAmount + delta));
                        Utils.setEmittingState(self.dischargeParticleSystems[self.currentFillType], true);               
			end;
						
			
		     end;
                if self.fillLevel == 0 then 
                        Utils.setEmittingState(self.dischargeParticleSystems[self.currentFillType], false);                      
                        self.currentFillType = FruitUtil.FRUITTYPE_UNKNOWN
                end; 
end;                
end;
	


function Triolet:draw()
	
end;






